--伊吹萃香用ai
--しなうす式/20220710check

require("function_pun_strage.lua")
head_req_list()

function main()
--シード生成、スレッド生成、base_states設定
	set_seedthreadstates()
--キャラ確認
	char_calling()
--ステージが 核融合炉心部 だと超反応モードに
	set_printsabot()

while true do
--スレッド外初期化
	while_top()

--●どちらかが体力無くなったら待機
	if interbattle_condi()==true then
		interbattle_exe()
--▼開幕行動▼
	elseif kaimaku_condi()==true then
		kaimaku_exe()
--▼移動起き上がり
	elseif my_act==97 or my_act==98 then --基本：画面端より遠ざかる。中央では相手から遠ざか…りたいが、設置技警戒のため、相手側に移動起き上がり。
		movedgetup_exe()

--▼簡易受け身▼：攻撃ないし回避いずれの目的であってもリカバリーポイントは限られるが、そういうことはさておき実装したもの
	elseif recovery_condi()==true then
		recovery_exe()

--▼台風になった時、フラグに従って「緋想の剣」を使用
	elseif y==0 and my_act<=10 and card_check(14) and flag_kishitu==1 then
		print("天候フラグＯＮ　⇒　「緋想の剣」使用");
		card_use(14);

--▼台風▼：近接状態からの強引な状況変更を行う行動。スペカなど使用。
	elseif react_rejecttaihu_condi()==true then
		react_rejecttaihu_exe()

--▼起き攻め▼
	elseif setplay_ongetup_condi()==true then
		setplay_ongetup_exe()
--▼ＨＪＣ▼
	--地上HJC
	elseif hjc_ground_condi()==true then
		hjc_ground_exe()
	--空中HJC
	elseif hjc_air_condi()==true then
		hjc_air_exe()

--▼反応行動
--反応：下段
	elseif 	react_lowattack_condi()==true then
		react_lowattack_exe()
--反応：地対空
	elseif react_g2a_condi()==true then
		react_g2a_exe()
--反応：低空飛翔
	elseif react_lowj6d_condi()==true then
		react_lowj6d_exe()
--上空追いかけ
	elseif ueoikake_condi()==true then
		ueoikake_exe()
--霊撃 or 霊撃札
	elseif reigeki_condi()==true then 
		print("拒否行動：霊撃　⇒　可能ならば使用");
		card_use(0)
		
--▼グレイズ：相手行動に対する反射or一定距離内のオブジェクト感知▼
--モーション反応グレイズ
	elseif
	graze_condition_xrange()==true and
	state_nottrueguard()==true and 
	my_airEX>=1 and 
	my_rei>=0 
	then--近距離時のグレイズ。のさばらせておくと、誤結界の原因となる。ガードの硬直間際ならok
		print("check 1 -> graze act X Range");
		graze_action_xrange()
			
--▼ ガード行動：簡易ガードルーチン▼
--▼ ガード反撃、龍魚の羽衣 13
	elseif hagoromo_1st_condi()==true or hagoromo_condi()==true then
		hagoromo_exe()

--回避結界
	elseif kekkai_condi()==true then
		kekkai_exe()

--▼ 宵越しの銭 12
	elseif yoikoshi_1st_condi()==true or yoikoshi_condi()==true then
		yoikoshi_exe()

--▼汎用中下段ガード
--基本は行動に対して後退入れ込み。下段のみ抽出して反応。通常射撃も同じく下段で受ける(けどメンドウだから今回は省き)。フラグを抜けてくるものは別個に対応
	elseif lowattack_aflags_condi()==true then
		guard_backexpectlowattack_exe()
	elseif overheadattack_aflags_condi()==true then
		guard_backoverheadattack_exe()
--下段判定をフィルタ
	elseif lowattack_flaged_condi()==true then
		guard_backexpectlowattack_exe()
--フラグを抜けてくるものをフィルタ
	elseif lowattack_unflaged_condi()==true then
		guard_backexpectlowattack_exe()
--屈状態では低空昇り攻撃には立てない
	elseif notstand_overhead_upjump_condi()==true then
		guard_backexpectlowattack_exe()
--以下、何もフィルタされなかった場合、立ちガード
	elseif guard_pun_condi()==true then
		guard_backoverheadattack_exe()

--[[▼オブジェが至近距離の場合、着地直前にｈｊを仕込む、タッチ＆ゴーグレイズ
	elseif touchandgo_00_condi() then
		touchandgo_00_exe()
--オブジェが至近距離の場合、ガードの前に、離陸
	elseif touchandgo_01_condi() then
		touchandgo_01_exe()
	elseif touchandgo_02_condi() then
		touchandgo_02_exe()
--]]
--オブジェが至近距離の場合、空中から地上へ飛翔　※咲夜：２D：120.0以上、３D：84.9以上必要
	elseif graze_pun_condi()==true then
		graze_pun_exe()
		
--遠距離時のグレイズ
	elseif graze_farground_condi() then
		graze_farground_exe()
	elseif graze_farair_condi() then
		graze_farair_exe()
		
--特定状況におけるガード
	elseif guard_objgimmick_condi()==true then
		guard_backexpectlowattack_exe()
--オブジェが至近距離の場合、ガード:射撃と打撃を重ねられると、しゃがみガードしてしまう。優先順位の変更が必要
	elseif guard_objclosedis_condi()==true then
		guard_backexpectlowattack_exe()
	
--▼起き上がり直後の行動
	elseif move_soonaftergetup_condi()==true then
		move_soonaftergetup_exe()

--▼コンボ▼
--簡易スペカコンボ

--踏鞴：
	elseif dis<=150 and ey==0 and
			enemy_act>=143 and enemy_act<=166 and
			my_hitstop<=2 and my_hitstop>=0 and my_hitstop==enemy_hitstop and 
			card_check(108) and
			math.random(10)==1 then
				print("スキルカード：踏鞴",dis);
				card_use(108);
	elseif dis<=150 and ey==0 and 
			enemy_act>=143 and enemy_act<=166 and
			my_hitstop<=6 and my_hitstop>=5 and my_hitstop==enemy_hitstop and 
			my_rei>=200 and
			card_check(108)==false and
			get_skill_lv(0,8)>=0 and
			math.random(10)==1 then
				print("コマンド：Ｂ踏鞴",dis);
				lvr236(ACT_B);
	elseif dis<=500 and dis>=150 and ey==0 and
			enemy_act>=143 and enemy_act<=166 and
			my_hitstop<=6 and my_hitstop>=5 and my_hitstop==enemy_hitstop and 
			my_rei>=200 and
			card_check(108)==false and
			get_skill_lv(0,8)>=0 then
				print("コマンド：Ｃ踏鞴",dis);
				lvr236(ACT_C);
--2B(CH)コンボ
	elseif my_act==402 and (enemy_act>=50 and enemy_act<=89) and get_correction(0,32)==true and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and my_rei>=200 then
		print("2B(CH)>2C");
		key_event2(ACT_C,ACT_DOWN);
--A>AA
	elseif my_act==300 and my_hitstop<=3 and my_hitstop>=1 and my_hitstop==enemy_hitstop and is_dir_front==true then
		print("コンボ：A>AA");
		key_event(ACT_A);
			
--AA>B
			elseif ey==0 and my_act==320 and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and (enemy_act>=50 and enemy_act<=89) and is_dir_front==true and my_rei>=200 then
				print("コンボ：AA>B");
				key_event(ACT_B);
--B>妖鬼‐密‐
				elseif ey==0 and my_act==400 and my_allframe>=11 and ((enemy_act>=50 and enemy_act<=89)or(enemy_act>=143 and enemy_act<=166)) and is_dir_front==true and my_rei>=200 then
					print("コンボ：B>妖鬼‐密‐");
					key_resetEX();
					key_event(ACT_D);
					lvr236(ACT_B);
--AA>AAA
		elseif ey==0 and my_act==320 and my_hitstop<=3 and my_hitstop>=1 and my_hitstop==enemy_hitstop and (enemy_act>=50 and enemy_act<=89) and is_dir_front==true then
		print("コンボ：ＡＡＡ");
			key_event(ACT_A);
--AAA>AAAA
			elseif ey==0 and my_act==321 and my_hitstop<=3 and my_hitstop>=1 and my_hitstop==enemy_hitstop and (enemy_act>=50 and enemy_act<=89) and is_dir_front==true then
				print("コンボ：ＡＡＡＡ");
				key_event(ACT_A);

--遠A>6A
	elseif my_act==301 and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and math.random(4)==1 then
		key_resetEX();
		print("遠Ａ＞6A");
		key_event2(ACT_A,front);
--遠A>3A
	elseif my_act==301 and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true then
		key_resetEX();
		print("遠Ａ＞3A");
		key_event2(ACT_A,d_front);
--2A>3A
	elseif my_act==303 and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and math.random(2)==1 then
		key_resetEX();
		print("2A＞3A");
		key_event2(ACT_A,d_front);
--2A>B
	elseif my_act==303 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and my_rei>=200 and math.random(4)==1 then
		print("2A>B");
		key_event(ACT_B);
--2A>2B
	elseif my_act==303 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and my_rei>=200 then
		print("2A>2B");
		key_event2(ACT_B,ACT_DOWN);
--6A>B
	elseif my_act==302 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and my_rei>=200 and math.random(4)==1 then
		print("6A>B");
		key_event(ACT_B);
--6A>2B
	elseif my_act==302 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and my_rei>=200 then
		print("6A>2B");
		key_event2(ACT_B,ACT_DOWN);
--3A>B
	elseif my_act==304 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and my_rei>=200 and math.random(4)==1 then
		print("6A>B");
		key_event(ACT_B);
--6A>2B
	elseif my_act==304 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166)) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and my_rei>=200 then
		print("6A>2B");
		key_event2(ACT_B,ACT_DOWN);
--B>C(画面端用
	elseif my_act==400 and ey==0 and my_allframe and my_allframe>=14 and my_allframe<=15 and (enemy_act>=143 and enemy_act<=166) and ((my_dir==1 and x>=1080) or (my_dir==-1 and x<=200)) and is_dir_front==true and my_rei>=200 then
		print("B>C");
		key_event(ACT_C);
--JA>J6A
	elseif my_act==306 and ((enemy_act>=50 and enemy_act<=89) or (enemy_act>=143 and enemy_act<=166 and math.random(8)==1)) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true then
		key_resetEX();
		print("ＪＡ＞Ｊ６Ａ");
		key_event2(ACT_A,front);
--JA>JB
	elseif my_act==306 and (enemy_act>=143 and enemy_act<=166) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true and (my_air<=1 or (my_air<=2 and weather==10)) then
		key_resetEX();
		print("JA>JB");
		key_event(ACT_B);
--J6A>J6B
	elseif my_act==307 and (enemy_act>=50 and enemy_act<=89) and my_hitstop<=3 and my_hitstop>=2 and my_hitstop==enemy_hitstop and is_dir_front==true then
		key_resetEX();
		print("JA>J6B");
		key_event2(ACT_B,front);
		
--固め

--▼攻撃▼

--▼spell card▼

--▼cost1

--霧符「雲集霧散」,206,606,g
	--Ground
	--air
	elseif card_check(206)==true and
	my_spell_more(500) and
	--dis2<200 and
	y==0 and
	--dis_y<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("霧符「雲集霧散」");
		for i=1,10 do
			card_use(206);
			yield()
		end

--▼cost2

--萃符「戸隠山投げ」,200,600,g,a
--Ground
elseif card_check(200)==true and
	my_spell_more(1000) and
	--dis2<200 and
	--y==0 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("萃符「戸隠山投げ」");
		for i=1,10 do
			card_use(200);
			yield()
		end

--酔神「鬼縛りの術」,201,601,g
--Ground
elseif card_check(201)==true and
	my_spell_more(1000) and
	dis<400 and
	y==0 and
	ey<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("酔神「鬼縛りの術」");
		for i=1,10 do
			card_use(201);
			yield()
		end

--鬼符「ミッシングパワー」,202,602,g
--Ground
--air
elseif card_check(202)==true and
	my_spell_more(1000) and
	dis<200 and
	y==0 and
	ey<200 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	--is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("鬼符「ミッシングパワー」");
		for i=1,10 do
			card_use(202);
			yield()
		end

--▼cost3

--四天王奥義「三歩壊廃」,212,612,g
--Ground
elseif card_check(212)==true and
	my_spell_more(1500) and
	dis<200 and
	y==0 and
	ey<100 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("四天王奥義「三歩壊廃」");
		for i=1,10 do
			card_use(212);
			yield()
		end

--▼cost4

--酔夢「施餓鬼縛りの術」,204,604,g
--Ground
elseif card_check(204)==true and
	my_spell_more(2000) and
	dis<400 and
	y==0 and
	ey<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("酔夢「施餓鬼縛りの術」");
		for i=1,10 do
			card_use(204);
			yield()
		end

--鬼神「ミッシングパープルパワー」,205,605,g
--Ground
--air
elseif card_check(205)==true and
	my_spell_more(2000) and
	dis<200 and
	y==0 and
	--dis_y<100 and
	ey<200 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	--is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("鬼神「ミッシングパープルパワー」");
		for i=1,10 do
			card_use(205);
			yield()
		end

--鬼火「超高密度燐禍術」,207,607,g
--Ground
elseif card_check(207)==true and
	my_spell_more(2000) and
	--dis>360 and
	y==0 and
	--ey<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("鬼火「超高密度燐禍術」");
		for i=1,10 do
			card_use(207);
			yield()
		end

--▼cost5

--萃鬼「天手力男投げ」,203,603,g
--Ground
elseif card_check(203)==true and
	my_spell_more(2500) and
	dis<300 and
	y==0 and
	ey<50 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("萃鬼「天手力男投げ」");
		for i=1,10 do
			card_use(203);
			yield()
		end

--鬼符「大江山悉皆殺し」,208,608,g
--Ground
elseif card_check(208)==true and
	my_spell_more(2500) and
	dis<120 and
	y==0 and
	ey<20 and
	not(my_act>=50 and my_act<180) and my_act<600 and 
	get_fflags(0,32)==true and
	get_fflags(0,8)==false and get_fflags(1,8)==false and 
	--enemy_obj_range_in(150,60)==false and 
	is_dir_front==true and 
	subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
		print("鬼符「大江山悉皆殺し」");
		for i=1,10 do
			card_use(208);
			yield()
		end
--]]
--[[
--▼skill card▼

	--▼スキル236

		--博麗アミュレット,100,500,g,a
			--g,a
				elseif get_skill_lv(0,0)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						lvr236(ACT_B);
				
				elseif get_skill_lv(0,0)>=0 and my_rei>=400 and 
					dis>450 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						lvr236(ACT_C);
					
				elseif card_check(100)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("博麗アミュレット");
						card_use(100);
		
		--妖怪バスター,104,505,g,a
			--g,a
				elseif get_skill_lv(0,4)>=0 and my_rei>=400 and 
					dis>200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						lvr236(ACT_B);
					
				elseif get_skill_lv(0,4)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						lvr236(ACT_C);
					
				elseif card_check(104)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("妖怪バスター");
						card_use(104);
		
		--拡散アミュレット,108,510,g

				elseif get_skill_lv(0,8)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						lvr236(ACT_B);
					
				elseif get_skill_lv(0,8)>=0 and my_rei>=400 and 
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						lvr236(ACT_C);
					
				elseif card_check(108)==true and my_rei>=400 and
					dis>300 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("拡散アミュレット");
						card_use(108);
		
	--▼スキル623

		--昇天脚,103,560,g

				elseif get_skill_lv(0,3)>=0 and my_rei>=400 and 
					dis<150 and
					y==0 and
					ey<200 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,3)>=0 and my_rei>=400 and 
					dis<150 and
					y==0 and
					ey<300 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					--enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						lvr623(ACT_C);
					
				elseif card_check(103)==true and my_rei>=400 and
					dis<150 and
					y==0 and
					ey<200 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("昇天脚");
						card_use(103);
		
		--抄地昇天脚,107,565,g
			--g
				elseif get_skill_lv(0,7)>=0 and my_rei>=400 and 
					dis<200 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,7)>=0 and my_rei>=400 and 
					dis<300 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						lvr623(ACT_C);
					
				elseif card_check(107)==true and my_rei>=400 and
					dis<200 and
					y==0 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("抄地昇天脚");
						card_use(107);
		
		--雨乞祈り,111,570,g,a
			--g,a
				elseif get_skill_lv(0,11)>=0 and my_rei>=400 and 
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						lvr623(ACT_B);
					
				elseif get_skill_lv(0,11)>=0 and my_rei>=400 and 
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						lvr623(ACT_C);
					
				elseif card_check(111)==true and my_rei>=400 and
					dis<200 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("雨乞祈り");
						card_use(111);

	--▼スキル421
		--亜空穴,102,540,g,a
			--g,a
				elseif get_skill_lv(0,2)>=0 and my_rei>=400 and 
					not(my_act>=50 and my_act<180) and my_act<600 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,2)>=0 and my_rei>=400 and 
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(102)==true and my_rei>=400 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("亜空穴");
						card_use(102);
		
		--封魔亜空穴,106,545,g,a
			--g,a
				elseif get_skill_lv(0,6)>=0 and my_rei>=400 and 
					dis<300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,6)>=0 and my_rei>=400 and 
					dis>300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(106)==true and my_rei>=400 and
					dis<300 and
					ey<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("封魔亜空穴");
						card_use(106);
		
		--刹那亜空穴,110,550,g
			--g
				elseif get_skill_lv(0,10)>=0 and my_rei>=400 and 
					dis2<300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					enemy_act>300 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						lvr421(ACT_B);
					
				elseif get_skill_lv(0,10)>=0 and my_rei>=400 and 
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==true and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						lvr421(ACT_C);
					
				elseif card_check(110)==true and my_rei>=400 and
					dis2<300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					enemy_act>300 and
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("刹那亜空穴");
						card_use(110);

	--▼スキル214
		--警醒陣,101,520,g,a
			--g,a
				elseif get_skill_lv(0,1)>=0 and my_rei>=400 and 
					dis>200 and dis<500 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,1)>=0 and my_rei>=400 and 
					dis>300 and dis<600 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						lvr214(ACT_C);
					
				elseif card_check(101)==true and my_rei>=400 and
					dis>200 and dis<500 and
					dis_y<50 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("警醒陣");
						card_use(101);	
		
		--繋縛陣,105,525,g,a
			--g,a
				elseif get_skill_lv(0,5)>=0 and my_rei>=400 and 
					dis2>300 and
					math.abs(enemy_xspeedEX)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,5)>=0 and my_rei>=400 and 
					dis2>300 and
					math.abs(enemy_yspeed)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						lvr214(ACT_C);
					
				elseif card_check(105)==true and my_rei>=400 and
					dis2>300 and
					math.abs(enemy_xspeedEX)>5 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("繋縛陣");
						card_use(105);
		
		--常置陣,109,530,g
			--g
				elseif get_skill_lv(0,9)>=0 and my_rei>=400 and 
					dis2>300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						lvr214(ACT_B);
					
				elseif get_skill_lv(0,9)>=0 and my_rei>=400 and 
					dis2>500 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						lvr214(ACT_C);
					
				elseif card_check(109)==true and my_rei>=400 and
					dis2>300 and
					y==0 and
					not(my_act>=50 and my_act<180) and my_act<600 and 
					get_fflags(0,32)==true and
					get_fflags(0,8)==false and get_fflags(1,8)==false and 
					enemy_obj_range_in(150,60)==false and 
					--is_dir_front==true and 
					subs_count>=530 and nega_count ~= 1 and math.random(64)==1 then
						print("常置陣");
						card_use(109);
--]]
			
--▼攻撃▼
--通常攻撃
--ＪＡ:最速
	elseif	y>0 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(my_act>=197 and my_act<=199)and
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and
	(y+my_yspeed*11+(11*(10*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*9		<=	120+30+20 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*9		>=	20-30 	and
				(ey+enemy_yspeed*9+(9*(8*e_gs))/2)	-	(y+my_yspeed*9+(9*(8*m_gs))/2)	<=	60		and
				(ey+enemy_yspeed*9+(9*(8*e_gs))/2)	-	(y+my_yspeed*9+(9*(8*m_gs))/2)	>=	0-120-60 	and subs_count>=530 and nega_count ~= 1 and math.random(2)==1 then
					print("JA",my_act,my_allframe,math.floor(y*10)/10);
					key_resetEX();
					key_event(ACT_A);
--ＪＡ:持続中ごろ
	elseif	y>0 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(my_act>=197 and my_act<=199)and
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and
	(y+my_yspeed*21+(21*(20*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*9		<=	120+30+20 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*9		>=	20-30 	and
				(ey+enemy_yspeed*19+(19*(18*e_gs))/2)	-	(y+my_yspeed*19+(19*(18*m_gs))/2)	<=	60		and
				(ey+enemy_yspeed*19+(19*(18*e_gs))/2)	-	(y+my_yspeed*19+(19*(18*m_gs))/2)	>=	0-120-60 	and subs_count>=530 and nega_count ~= 1 and math.random(2)==1 then
					print("JA",my_act,my_allframe,math.floor(y*10)/10);
					key_resetEX();
					key_event(ACT_A);
					
--Ｊ８Ａ:適当計算
	elseif	y>0 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and
	(y+my_yspeed*11+(11*(10*m_gs))/2)>0 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*11		<=	60+30 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*11		>=	60-30 	and
				(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	-	y	<=	280 		and
				(ey+enemy_yspeed*11+(11*(10*e_gs))/2)	-	y	>=	160-120 	and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
					print("Ｊ８Ａ");
					key_resetEX();
					key_event2(ACT_A,ACT_UP);

--J2A
	elseif	y>0 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and
	(y+my_yspeed*15+(15*(14*m_gs))/2)>0 	and
				(ex-x)*my_dir-(enemy_xspeedEX)*13		<=	260+30 	and
				(ex-x)*my_dir-(enemy_xspeedEX)*13		>=	180-30 	and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	y	<=	-120 		and
				(ey+enemy_yspeed*13+(13*(12*e_gs))/2)	-	y	>=	-200-120 	and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
					print("J2A");
					key_resetEX();
					key_event2(ACT_A,ACT_DOWN);
--J6A
	elseif	y>0 and 
	(my_act<=10 or (my_act>=180 and my_act<300)) and 
	not(enemy_act>=98 and enemy_act<=98) and
	not(enemy_act>=197 and enemy_act<=199) and
	enemy_obj_range_in(150,60)==false and
	is_dir_front and
	(y+my_yspeed*16+(16*(15*m_gs))/2)>0 	and
				(ex-x)*my_dir-(enemy_xspeedEX)*14		<=	220+30 	and
				(ex-x)*my_dir-(enemy_xspeedEX)*14		>=	40-30 	and
				(ey+enemy_yspeed*14+(14*(13*e_gs))/2)	-	y	<=	140 		and
				(ey+enemy_yspeed*14+(14*(13*e_gs))/2)	-	y	>=	-40-120 	and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
					print("J2A");
					key_resetEX();
					key_event2(ACT_A,ACT_DOWN);--

--対空４Ａ
	elseif y==0 and ey>0 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and
	((not(enemy_act>=50 and enemy_act<=166)and math.random(1+5)==1) or (enemy_act>=50 and enemy_act<=166)) and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*9		<=	110+30 	and
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*9		>=	20-30 	and
				(ey+enemy_yspeed*9+(9*(8*e_gs))/2)	-	(y+my_yspeed*9+(9*(8*m_gs))/2)	<=	140 		and
				(ey+enemy_yspeed*9+(9*(8*e_gs))/2)	-	(y+my_yspeed*9+(9*(8*m_gs))/2)	>=	60-120 	and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("対空4Ａ");
		key_event2(ACT_A,back);
--対空9HJ>JＡ:14F それなりに機能する。対地上りJAも兼ねる。
	elseif y==0 and 
	(ey>0 or
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162))
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166))
			)
		)
	) and 
	enemy_obj_range_in(150,60)==false and
	my_act<=10 and 
	not(enemy_act>=97 and enemy_act<=98) and 
	not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and
	(
		(not(enemy_act>=50 and enemy_act<=166)) or (enemy_act>=50 and enemy_act<=166)
	) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		<=	170+30 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		>=	80-30 	and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	<=	150 		and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	>=	110-120 	then
		print("対空9HJ>JＡ");
		key_event2(ACT_D,u_front)
		key_reset()
		wait(2)
		key_event(ACT_A);--]]
--対空8HJ>JＡ:14F
	elseif y==0 and 
	(ey>0 or
		(
			(enemy_char~=19 and (enemy_act==0 or (enemy_act>=5 and enemy_act<=10) or (enemy_act>=150 and enemy_act<=153) or (enemy_act>=159 and enemy_act<=162))
			) or
			(enemy_char==19 and ((enemy_act>=1 and enemy_act<=3) or (enemy_act>=154 and enemy_act<=157) or (enemy_act>=163 and enemy_act<=166))
			)
		)
	) and 
	enemy_obj_range_in(150,60)==false and
	my_act<=10 and 
	not(enemy_act>=97 and enemy_act<=98) and 
	not(enemy_act>=197 and enemy_act<=199) and 
	is_dir_front==true and
	(
		(not(enemy_act>=50 and enemy_act<=166)) or (enemy_act>=50 and enemy_act<=166)
	) and 
	subs_count>=530 and nega_count ~= 1 and math.random(4)==1 and 
				(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		<=	50+30 	and
				--(ex-x)*my_dir-(my_xspeedEX+enemy_xspeedEX)*15		>=	-40-30 	and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	<=	181 		and
				(ey+enemy_yspeed*15+(15*(14*e_gs))/2)	-	(y+my_yspeed*15+(15*(14*m_gs))/2)	>=	121-120 	then
		print("対空8HJ>JＡ");
		key_event2(ACT_D,ACT_UP)
		key_reset()
		wait(2)
		key_event(ACT_A);--]]
--ダッシュ＞２Ａ
	elseif dis<=180 and my_act==200 and my_allframe>=10 and ey==0 and enemy_obj_range_in(150,60)==false and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and 
	((not(enemy_act>=50 and enemy_act<=166)and math.random(5)==1) or (enemy_act>=50 and enemy_act<=166)) and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("刻み２Ａ");
		key_event2(ACT_A,ACT_DOWN);
--Ａ
	elseif (dis<=120 or (dis>=180 and dis<=220)) and y==0 and ey<100 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and 
	((not(enemy_act>=50 and enemy_act<=166)and math.random(5)==1) or (enemy_act>=50 and enemy_act<=166)) and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("Ａ");
		key_event(ACT_A);
--ＤＡ
--	elseif dis<=250 and dis>=150 and y==0 and ey<100 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and 
--	((not(enemy_act>=50 and enemy_act<=166)and math.random(1+5)==1) or (enemy_act>=50 and enemy_act<=166)) and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
--		print("ＤＡ");
--		key_on(frontEX());
--		key_event2(ACT_D,ACT_A);
--2A：硬直差し込み
	elseif dis<=140 and y==0 and ey==0 and enemy_obj_range_in(150,60)==false and my_act<=10 and enemy_act>=300 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("硬直差し込み：2A");
		key_event2(ACT_A,ACT_DOWN);
--B:硬直差し込み
	elseif dis<=500 and y==0 and ey>0 and enemy_obj_range_in(150,60)==false and my_act<=10 and enemy_act>=300 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("硬直差し込み：B");
		key_event(ACT_B);
--５Ｂ
	elseif dis>300 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("５Ｂ");
		key_event(ACT_B);
--2C：対空
	elseif dis>250 and y==0 and ey>180 and enemy_obj_range_in(150,60)==false and my_act<=10 and not(enemy_act>=97 and enemy_act<=98) and not(enemy_act>=197 and enemy_act<=199) and is_dir_front==true and subs_count>=530 and nega_count ~= 1 and math.random(4)==1 then
		print("対空：2C");
		key_event2(ACT_C,ACT_DOWN);
--6C
--]]
--中距離以上からの８ｈｊ
	elseif move_8hjattakeovermidrange_condi()==true then
		print("中距離以上で８ＨＪ");
		key_event2(ACT_D,ACT_UP);
--中距離からのダッシュ
	elseif move_6dattakeovermidrange_condi()==true then
		print("ダッシュ接近");
		key_event2(ACT_D,front);
--低空飛翔で接近
	elseif move_approachbylowflaying_condi()==true then
		move_approachbylowflaying_exe()
--８８３飛翔
	elseif move_approachby883d_condi()==true then
		move_approachby883d_exe()
--▼ 終端運動
--▼ 相手上空へ飛び上がった際の処理
	elseif move_attakeoverhead_condi()==true then
		move_attakeoverhead_exe()
--▼ 終端機動
	--▼ 対台風時
	elseif move_terminationtaihu_condi()==true then
		move_terminationtaihu_exe()
	--▼ 終端機動1
	--台風じゃない時だが…
	elseif move_termination1_condi()==true then
		move_termination1_exe()
	--▼ 終端機動2
	--ただ動く事で自律性を錯覚させる事が目的の機動。静止やラインの設定に大きな根拠はない。
	--霊力が一定の評価を下回った場合、実行しない。
	elseif move_termination2_condi()==true then
		move_termination2_exe()
	end
	
	yield()
end
end